﻿using System;
using System.Windows;
using System.Windows.Controls;
using Microsoft.LightSwitch.Presentation;
using System.Windows.Data;
using Microsoft.LightSwitch;
using System.Collections.Generic;
using LightSwitchApplication;

namespace SilverlightClass
{
    public partial class SilverlightDataGrid : UserControl
    {
        public SilverlightDataGrid()
        {
            InitializeComponent();
        }

        private void DeleteButton_Click(object sender, RoutedEventArgs e)
        {
            // Get a reference to the LightSwitch DataContext 
            var objDataContext = (IContentItem)this.DataContext;

            // Get a reference to the LightSwitch Screen
            var Screen =
                (Microsoft.LightSwitch.Client.IScreenObject)objDataContext.Screen;

            // Get an instance of the Button
            Button objButton = (Button)sender;

            // Get the record Id from the Tag
            int Id = Convert.ToInt32(objButton.Tag);

            // Disable the Delete Button
            objButton.IsEnabled = false;

            // Delete the Record in LightSwitch
            Screen.Details.Dispatcher.BeginInvoke(() =>
            {
                // Get access to the DataWorkspace
                // Note: you must referece the 'Common' Project for this code to work
                DataWorkspace DataWorkspace =
                    (Screen.Details.DataWorkspace as LightSwitchApplication.DataWorkspace);

                // Get the HelpDeskTicket
                LightSwitchApplication.HelpDeskTicket DeletedHelpDeskTicket =
                    DataWorkspace.ApplicationData.HelpDeskTickets
                    .Where(x => x.Id == Id).FirstOrDefault();

                if (DeletedHelpDeskTicket != null)
                {
                    // Delete the HelpDeskTicket
                    DeletedHelpDeskTicket.Delete();            
                }
            });
        }
    }

    public class StatusChoicesProvider
    {
        public List<string> StatusChoices
        {
            get
            {
                return new List<string>() 
                { 
                    "New", 
                    "Active",
                    "OnHold",
                    "Cancelled",
                    "Resolved",
                };
            }
        }
    }
}
